# Ore UI meta-repo

<img src="logo.png" width="400px" />

Open-source building blocks from Mojang Studios to construct game UIs using web tech.

## What is this?

Minecraft Bedrock Edition is migrating its UI system to a solution based on [web standards](https://coherent-labs.com/products/coherent-gameface/). This repository contains some infrastructure bits used internally, but that can also be shared across other game studios and general-purpose web applications.

The new system is based on:

- [React](https://reactjs.org/)
- [TypeScript](https://www.typescriptlang.org/)

## Packages

- [`@react-facet`](packages/@react-facet): Observable-based state management for performant game UIs built in React
- `@mojang/react-gamepad`: Declarative Gamepad focus navigation (**coming soon**)
- More to come!

## Documentation

We currently only have one package that is open-source, and its documentation is available at https://react-facet.mojang.com/.

The source of the documentation (for contributions) is available at the [documentation branch](https://github.com/Mojang/ore-ui/tree/documentation).

## Team

<table>
  <tbody>
    <tr>
      <td align="center" valign="top">
        <img width="150" height="150" src="https://github.com/pirelenito.png?s=150">
        <br>
        <a href="https://github.com/pirelenito">Paulo Ragonha</a>
      </td>
      <td align="center" valign="top">
        <img width="150" height="150" src="https://github.com/xaviervia.png?s=150">
        <br>
        <a href="https://github.com/xaviervia">Fernando Vía Canel</a>
      </td>
      <td align="center" valign="top">
        <img width="150" height="150" src="https://github.com/marlonicus.png?s=150">
        <br>
        <a href="https://github.com/marlonicus">Marlon Huber-Smith</a>
      </td>
      <td align="center" valign="top">
        <img width="150" height="150" src="https://github.com/prog666.png?s=150">
        <br>
        <a href="https://github.com/prog666">Danila Dergachev</a>
      </td>
     </tr>
  </tbody>
</table>

## Logo

**React Facet** and **Ore UI** logos designed by [Nekofresa](https://twitter.com/nekofresa).

## Contributors

<a href="https://github.com/Warwolt" target="_blank"><img width="42" height="42" src="https://github.com/Warwolt.png?s=42"></a>
<a href="https://github.com/lucaslsf" target="_blank"><img width="42" height="42" src="https://github.com/lucaslsf.png?s=42"></a>
<a href="https://github.com/volgar" target="_blank"><img width="42" height="42" src="https://github.com/volgar.png?s=42"></a>
<a href="https://github.com/SleepyWerewolf" target="_blank"><img width="42" height="42" src="https://github.com/SleepyWerewolf.png?s=42"></a>
<a href="https://github.com/Joslind" target="_blank"><img width="42" height="42" src="https://github.com/Joslind.png?s=42"></a>
<a href="https://github.com/OskarPedersen" target="_blank"><img width="42" height="42" src="https://github.com/OskarPedersen.png?s=42"></a>
<a href="https://github.com/pillimoj" target="_blank"><img width="42" height="42" src="https://github.com/pillimoj.png?s=42"></a>
<a href="https://github.com/timlindeberg" target="_blank"><img width="42" height="42" src="https://github.com/timlindeberg.png?s=42"></a>
<a href="https://github.com/adwenture" target="_blank"><img width="42" height="42" src="https://github.com/adwenture.png?s=42"></a>
